class LSystem
	attr_reader :output

	def initialize( in_axiom, in_rules, in_iterations = 0 )
		@axiom = in_axiom
		@output = in_axiom
		@rules = in_rules
		
		in_iterations.times do iterate end

		return @output
	end
	
	def iterate
		temp_string = ""
		@output.scan( /./ ) do |letter|
			rule_hit = false
			@rules.each do |rule|
				if( letter[ rule[0] ] )
					rule_hit = true
					temp_string << rule[1]
				end
			end
			if( not rule_hit )
				temp_string << letter
			end
		end
		@output = temp_string
	end
end

