require 'cairo'

class CairoRenderer
	def initialize( in_x, in_y, in_filename, in_instructions )
		surface = Cairo::ImageSurface.new(Cairo::FORMAT_ARGB32, in_x, in_y)
		cr = Cairo::Context.new(surface)
		
		# fill background with white
		cr.set_source_rgba(1.0, 1.0, 1.0, 1.0)
		cr.paint

		cr.set_line_join(Cairo::LINE_JOIN_ROUND)
		cr.set_line_width(2)
		cr.set_source_rgba( 0.0, 0.0, 0.0, 1.0 )

		the_pen = Pen.new( [250,250], "cairo", cr )
		
		cr = the_pen.follow_instructions( in_instructions )

		# stroke!
		cr.stroke

		cr.target.write_to_png( in_filename )
		cr.target.finish
	end
end