class Turtle
	attr_accessor :instructions
	
	def initialize
		@instructions = ""
	end
	
	def pen_up
		@instructions << "^"
	end
	
	def pen_down
		@instructions << "#"
	end
	
	def set_position( in_x, in_y )
		@instructions << "SP#{in_x},#{in_y}"
	end
	
	def set_heading( in_theta )
		@instructions << "SH#{in_theta}"
	end
	
	def forward( in_amount = nil )
		@instructions << "F#{in_amount}"
	end
	
	def back( in_amount = nil )
		@instructions << "B#{in_amount}"
	end
	
	def turn_right( in_amount = nil )
		if( in_amount )
			@instructions << "TR#{in_amount}"
		else
			@instructions << "-"
		end
	end

	def turn_left( in_amount = nil )
		if( in_amount )
			@instructions << "TL#{in_amount}"
		else
			@instructions << "+"
		end
	end
	
	def set_color( in_r, in_g, in_b )
		@instructions << "C#{in_r},#{in_g},#{in_b}"
	end
	
	def set_speed( in_coef )
		@instructions << "@#{in_coef}"
	end
	
	def up_theta( in_amount )
		@instructions << "\\#{in_amount}"
	end
	
	def down_theta( in_amount )
		@instructions << "/#{in_amount}"
	end
	
	def set_theta( in_theta )
		@instructions << "ST#{in_theta}"
	end
	
	def about_face
		@instructions << "|"
	end
	
	def push
		@instructions << "["
	end
	
	def pop
		@instructions << "]"
	end
end